//+------------------------------------------------------------------+
//|                                                 Hull_Candles.mq5 |
//|                                           Copyright  2007, None |
//|                                      Planet.Earth.Redistribution |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, None"
#property link      "Planet.Earth.Redistribution"
#property description "Hull_Candles"

//----   
#property version   "1.00"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 5
//----     
#property indicator_plots   1
//----      
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1  clrDarkTurquoise,clrDeepPink
//----   
#property indicator_label1  "Hull Open;Hull High;Hull Low;Hull Close"

//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//----    CXMA   SmoothAlgorithms.mqh
CXMA XMAO1,XMAL1,XMAH1,XMAC1;
CXMA XMAO2,XMAL2,XMAH2,XMAC2;
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input Smooth_Method HMA_Method=MODE_JJMA; // 
input uint HLength=30; //                      
input int  HPhase=100; // ,
                       // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
//+----------------------------------------------+

//----   ,    
//      
double ExtOpenBuffer[];
double ExtHighBuffer[];
double ExtLowBuffer[];
double ExtCloseBuffer[];
double ExtColorBuffer[];
//----
int min_rates_total,HLength2;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----    
   min_rates_total=XMAO1.GetStartBars(HMA_Method,HLength,HPhase)+2;
   HLength2=int(MathFloor(HLength/2));

//----       
   XMAO1.XMALengthCheck("HLength", HLength);
   XMAO1.XMAPhaseCheck("HPhase", HPhase, HMA_Method);

//----      
   SetIndexBuffer(0,ExtOpenBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,ExtHighBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,ExtLowBuffer,INDICATOR_DATA);
   SetIndexBuffer(3,ExtCloseBuffer,INDICATOR_DATA);
//----     ,     
   SetIndexBuffer(4,ExtColorBuffer,INDICATOR_COLOR_INDEX);
//----       1
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,min_rates_total);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----         
   string short_name="Hull_Candles";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//----   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----    
   int first,bar;
   double haOpen,haHigh,haLow,haClose;
   double XmaOpen,XmaHigh,XmaLow,XmaClose;
   double XmaOpen1,XmaHigh1,XmaLow1,XmaClose1;
   double XmaOpen2,XmaHigh2,XmaLow2,XmaClose2;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=1; //      
     }
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      XmaOpen1  = XMAO1.XMASeries(1, prev_calculated, rates_total, HMA_Method, HPhase, HLength, open [bar], bar, false);
      XmaClose1 = XMAC1.XMASeries(1, prev_calculated, rates_total, HMA_Method, HPhase, HLength, close[bar], bar, false);
      XmaHigh1  = XMAH1.XMASeries(1, prev_calculated, rates_total, HMA_Method, HPhase, HLength, high [bar], bar, false);
      XmaLow1   = XMAL1.XMASeries(1, prev_calculated, rates_total, HMA_Method, HPhase, HLength, low  [bar], bar, false);
      //----
      XmaOpen2  = XMAO2.XMASeries(1, prev_calculated, rates_total, HMA_Method, HPhase, HLength2, open [bar], bar, false);
      XmaClose2 = XMAC2.XMASeries(1, prev_calculated, rates_total, HMA_Method, HPhase, HLength2, close[bar], bar, false);
      XmaHigh2  = XMAH2.XMASeries(1, prev_calculated, rates_total, HMA_Method, HPhase, HLength2, high [bar], bar, false);
      XmaLow2   = XMAL2.XMASeries(1, prev_calculated, rates_total, HMA_Method, HPhase, HLength2, low  [bar], bar, false);
      //----
      XmaOpen=(2*XmaOpen2-XmaOpen1);
      XmaClose=(2*XmaClose2-XmaClose1);
      XmaHigh=(2*XmaHigh2-XmaHigh1);
      XmaLow=(2*XmaLow2-XmaLow1);

      haHigh=MathMax(XmaHigh,MathMax(ExtOpenBuffer[bar-1],ExtCloseBuffer[bar-1]));
      haLow=MathMin(XmaLow,MathMin(ExtOpenBuffer[bar-1],ExtCloseBuffer[bar-1]))/2;
      haClose=(XmaOpen+XmaHigh+XmaLow+XmaClose)/4;

      if(bar<=min_rates_total)
        {
         ExtOpenBuffer [bar]=XmaOpen;
         ExtCloseBuffer[bar]=XmaClose;
         ExtHighBuffer [bar]=XmaHigh;
         ExtLowBuffer  [bar]=XmaLow;

         continue;
        }

      ExtOpenBuffer [bar]=haOpen;
      ExtCloseBuffer[bar]=haClose;
      ExtHighBuffer [bar]=haHigh;
      ExtLowBuffer  [bar]=haLow;


      //---  
      if(ExtOpenBuffer[bar]<ExtCloseBuffer[bar]) ExtColorBuffer[bar]=0.0;
      else                                       ExtColorBuffer[bar]=1.0;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
